/*
 * Execute_Command_LED.c
 *
 *  Created on: 2024/11/18
 *      Author: egaono-electronics
 */

#include "Execute_Command_LED.h"


#include <string.h>



//----------------------------------------------------------
// 受信コマンドを実行する。 : LED点滅
//----------------------------------------------------------
// 引数;
// uint16_t uint16_ReceiveLength : 受信データ数
// uint8_t *puint8_aReceiveData :
//              受信データが格納されているBufferのポインタ
// uint8_t *puint8_aSendData :
//              応答送信データを格納するBufferのポインタ

// struct sParam_Blink_LED_ST *pstructParam_Blink_LED_ST :
//              ST LED点滅用パラメータの構造体のポインタ


// 戻り値; 応答送信データ数
//----------------------------------------------------------
uint16_t Execute_Command_LED(uint16_t uint16_ReceiveLength,
                             uint8_t *puint8_aReceiveData,
                             uint8_t *puint8_aSendData,
            struct sParam_Blink_LED_ST *pstructParam_Blink_LED_ST)
{
  uint16_t uint16_I;
  uint16_t uint16_SendLength = 0;


  //------------------------------------------------------------
  // Command処理
  //------------------------------------------------------------

  //------------------------------------------------------------
  // LED1(緑) 点滅間隔切り替え
  //------------------------------------------------------------
  if(memcmp(puint8_aReceiveData, "LED1 B0\r\n", 9) == 0){
    // LED1(緑) : 点灯1000mSec / 消灯2000mSec
    pstructParam_Blink_LED_ST->uint16_Time_LED_ST_ON = (uint16_t)1000;
    pstructParam_Blink_LED_ST->uint16_Time_LED_ST_OFF = (uint16_t)2000;

    pstructParam_Blink_LED_ST->int16_Restart_LED_ST = 1;
                                    // Status LED再起動フラグON
  }
  else if(memcmp(puint8_aReceiveData, "LED1 B1\r\n", 9) == 0){
    // LED1(緑) : 点灯100mSec / 消灯100mSec
    pstructParam_Blink_LED_ST->uint16_Time_LED_ST_ON = (uint16_t)100;
    pstructParam_Blink_LED_ST->uint16_Time_LED_ST_OFF = (uint16_t)100;

    pstructParam_Blink_LED_ST->int16_Restart_LED_ST = 1;
                                    // Status LED再起動フラグON
  }
  else if(memcmp(puint8_aReceiveData, "LED1 B2\r\n", 9) == 0){
    // LED1(緑) : 点灯200mSec / 消灯200mSec
    pstructParam_Blink_LED_ST->uint16_Time_LED_ST_ON = (uint16_t)200;
    pstructParam_Blink_LED_ST->uint16_Time_LED_ST_OFF = (uint16_t)200;

    pstructParam_Blink_LED_ST->int16_Restart_LED_ST = 1;
                                    // Status LED再起動フラグON
  }
  else if(memcmp(puint8_aReceiveData, "LED1 B3\r\n", 9) == 0){
    // LED1(緑) : 点灯300mSec / 消灯300mSec
    pstructParam_Blink_LED_ST->uint16_Time_LED_ST_ON = (uint16_t)300;
    pstructParam_Blink_LED_ST->uint16_Time_LED_ST_OFF = (uint16_t)300;

    pstructParam_Blink_LED_ST->int16_Restart_LED_ST = 1;
                                    // Status LED再起動フラグON
  }
  else if(memcmp(puint8_aReceiveData, "LED1 B4\r\n", 9) == 0){
    // LED1(緑) : 点灯400mSec / 消灯400mSec
    pstructParam_Blink_LED_ST->uint16_Time_LED_ST_ON = (uint16_t)400;
    pstructParam_Blink_LED_ST->uint16_Time_LED_ST_OFF = (uint16_t)400;

    pstructParam_Blink_LED_ST->int16_Restart_LED_ST = 1;
                                    // Status LED再起動フラグON
  }
  else if(memcmp(puint8_aReceiveData, "LED1 B5\r\n", 9) == 0){
    // LED1(緑) : 点灯500mSec / 消灯500mSec
    pstructParam_Blink_LED_ST->uint16_Time_LED_ST_ON = (uint16_t)500;
    pstructParam_Blink_LED_ST->uint16_Time_LED_ST_OFF = (uint16_t)500;

    pstructParam_Blink_LED_ST->int16_Restart_LED_ST = 1;
                                    // Status LED再起動フラグON
  }


  // エコーバック
  for(uint16_I = 0; uint16_I < uint16_ReceiveLength; uint16_I++){
    puint8_aSendData[uint16_I] = puint8_aReceiveData[uint16_I];
  }

  uint16_SendLength = uint16_ReceiveLength;

  return(uint16_SendLength);
}
